//
//  LiveRoom-RoomExtraInfo_h
//  zegoliveroom
//
//  Copyright © 2020年 Zego. All rights reserved.
//
//

#ifndef LiveRoom_RoomExtraInfo_h
#define LiveRoom_RoomExtraInfo_h

#include "./LiveRoomDefines.h"
#include "./LiveRoomCallback-RoomExtraInfo.h"

namespace ZEGO
{
    namespace LIVEROOM
    {
        /**
         设置 RoomExtraInfo 通知的回调

         @param pCB 回调对象指针
         @return true 成功，false 失败
         */
        ZEGO_API bool SetRoomExtraInfoCallback(IRoomExtraInfoCallback* pCB);
    
        /**
         更新房间属性 登录房间成功后使用

         @param pszKey 房间额外信息key值，不能超过 10字节, 不允许为空字符串, 一个房间内只允许1个消息类型
         @param pszValue 房间属性内容，不能超过 128 字节, 允许为空字符串
         @param pszRoomID 可选，房间 ID, 为 nullptr 时，表示往默认房间发送
         @return 发送序号 seq，-1 表示失败
         @attention 单房间模式，设置 pszRoomID 为当前房间或者为空，都往当前房间发送。
         @attention 多房间模式（通过 SetRoomMode 接口开启 ZegoRoomModeMultiRoom），必须指定 pszRoomID，否则调用失败。
        */
        ZEGO_API int SetRoomExtraInfo(const char *pszKey, const char *pszValue, const char* pszRoomID = nullptr);
    }
}

#endif /* LiveRoom_RoomExtraInfo_h */
