#ifndef zego_api_network_time_h
#define zego_api_network_time_h

#include "zego-api-defines.h"


namespace ZEGO
{
    namespace NETWORKTIME
    {
        struct ZegoNetworkTimeInfo
        {
            /**
             * 同步后的网络时间戳，0表示尚未同步
             */
            unsigned long long timestamp;

            /**
             * 最大误差
             */
            int maxDeviation;

            ZegoNetworkTimeInfo()
            {
                timestamp = 0;
                maxDeviation = 0;
            }
        };

        class IZegoNetworkTimeCallback
        {
        public:
            /**
            * 内部同步网络时间成功回调
            *
            */
            virtual void OnNetworkTimeSynchronized() {};

            virtual ~IZegoNetworkTimeCallback() {}
        };

        /**
        * 设置网络时间回调,建议InitSDK 前设置
        *
        * @param pCB callback指针
        */
        ZEGOAVKIT_API void SetNetworkTimeCallback(IZegoNetworkTimeCallback* pCB);

        /**
         * 获取同步网络时间戳
         * 
         * @return 返回同步的时间戳，如果返回 0，表示尚未同步
         */
        ZEGOAVKIT_API ZegoNetworkTimeInfo GetNetworkTimeInfo();
    }
}

#endif //zego_api_network_time_h